# file      : build/cxx/gnu/o-l.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004-2006 Boris Kolpackov
# license   : GNU GPL v2; see accompanying LICENSE file

$(call include,$(bld_root)/cxx/gnu/configuration.make)

vpath %.a $(cxx_gnu_libraries)
vpath %.so $(cxx_gnu_libraries)

ifdef c_lib_type

.PHONY: $(out_base)/%.l.o.clean

ifeq ($(c_lib_type),archive)

$(out_base)/%.l: ar ?= ar
$(out_base)/%.l: ar_options ?= -rc

$(out_base)/%.l: | $$(dir $$@).
	$(call message,"ar  $@",$(ar) $(ar_options) $(@D)/lib$(basename $(@F)).a $(filter %.o,$^) && \
echo $(@D)/lib$(basename $(@F)).a >$@ && \
echo $(cpp_options) >>$@ && \
echo "$(patsubst %.l,`cat %.l`,$(filter %.a %.so %.l,$^))" >>$@)


$(out_base)/%.l.o.clean:
	$(call message,rm $$1,rm -f $$1 $(@D)/$(patsubst %.l.o.clean,lib%.a,$(@F)),$(basename $(basename $@)))

else

$(out_base)/%.l: ld := $(cxx_gnu)
$(out_base)/%.l: ld_options := $(cxx_gnu_optimization_options) $(cxx_gnu_debugging_options)
$(out_base)/%.l: comma_ := ,
$(out_base)/%.l: cxx_pic_options := -fPIC

$(out_base)/%.l: | $$(dir $$@).
	$(call message,"ld  $@",$(ld) -shared $(ld_options) \
-o $(@D)/lib$(basename $(@F)).so -Wl$(comma_)-soname=lib$(basename $(@F)).so \
$(foreach f,$^,$(if $(patsubst %.l,,$f),$f,$(shell sed -e '/^-I/ d' $f))) && \
echo $(@D)/lib$(basename $(@F)).so >$@ && \
echo -Wl$(comma_)-rpath$(comma_)$(@D) >>$@ && \
echo $(cpp_options) >>$@ && \
echo "$(patsubst %.l,`cat %.l`,$(filter %.a %.so %.l,$^))" >>$@)

$(out_base)/%.l.o.clean:
	$(call message,rm $$1,rm -f $$1 $(@D)/$(patsubst %.l.o.clean,lib%.so,$(@F)),$(basename $(basename $@)))

endif
endif
